
package net.ericaro.neoevents.java.awt.datatransfer;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.awt.datatransfer.FlavorListener} that uses annotations to convert any objects into
 *  an FlavorListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>flavorsChanged</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addFlavorListener(new FlavorListener(this) );
 *     
 *     ...    
 *     
 *     &#64;FlavorListener.flavorsChanged
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the FlavorListener.flavorsChanged event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class FlavorListener extends AbstractEvent implements java.awt.datatransfer.FlavorListener{

    /** Creates an instance of Interface java.awt.datatransfer.FlavorListener that will forward every call to the target's methods annotated with:
     * <ul><li>flavorsChanged</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public FlavorListener(Object target) {
        super(target
            ,flavorsChanged.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.awt.datatransfer.FlavorListener.flavorsChanged()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface flavorsChanged {}
    @Override public void flavorsChanged(java.awt.datatransfer.FlavorEvent arg0) { fire(flavorsChanged.class, arg0); } 

    
    
}