
package net.ericaro.neoevents.java.awt.dnd;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.awt.dnd.DragGestureListener} that uses annotations to convert any objects into
 *  an DragGestureListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>dragGestureRecognized</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addDragGestureListener(new DragGestureListener(this) );
 *     
 *     ...    
 *     
 *     &#64;DragGestureListener.dragGestureRecognized
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the DragGestureListener.dragGestureRecognized event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class DragGestureListener extends AbstractEvent implements java.awt.dnd.DragGestureListener{

    /** Creates an instance of Interface java.awt.dnd.DragGestureListener that will forward every call to the target's methods annotated with:
     * <ul><li>dragGestureRecognized</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public DragGestureListener(Object target) {
        super(target
            ,dragGestureRecognized.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.awt.dnd.DragGestureListener.dragGestureRecognized()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface dragGestureRecognized {}
    @Override public void dragGestureRecognized(java.awt.dnd.DragGestureEvent arg0) { fire(dragGestureRecognized.class, arg0); } 

    
    
}