
package net.ericaro.neoevents.java.awt.dnd;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.awt.dnd.DragSourceMotionListener} that uses annotations to convert any objects into
 *  an DragSourceMotionListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>dragMouseMoved</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addDragSourceMotionListener(new DragSourceMotionListener(this) );
 *     
 *     ...    
 *     
 *     &#64;DragSourceMotionListener.dragMouseMoved
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the DragSourceMotionListener.dragMouseMoved event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class DragSourceMotionListener extends AbstractEvent implements java.awt.dnd.DragSourceMotionListener{

    /** Creates an instance of Interface java.awt.dnd.DragSourceMotionListener that will forward every call to the target's methods annotated with:
     * <ul><li>dragMouseMoved</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public DragSourceMotionListener(Object target) {
        super(target
            ,dragMouseMoved.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.awt.dnd.DragSourceMotionListener.dragMouseMoved()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface dragMouseMoved {}
    @Override public void dragMouseMoved(java.awt.dnd.DragSourceDragEvent arg0) { fire(dragMouseMoved.class, arg0); } 

    
    
}