
package net.ericaro.neoevents.java.awt.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.awt.event.AdjustmentListener} that uses annotations to convert any objects into
 *  an AdjustmentListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>adjustmentValueChanged</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addAdjustmentListener(new AdjustmentListener(this) );
 *     
 *     ...    
 *     
 *     &#64;AdjustmentListener.adjustmentValueChanged
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the AdjustmentListener.adjustmentValueChanged event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class AdjustmentListener extends AbstractEvent implements java.awt.event.AdjustmentListener{

    /** Creates an instance of Interface java.awt.event.AdjustmentListener that will forward every call to the target's methods annotated with:
     * <ul><li>adjustmentValueChanged</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public AdjustmentListener(Object target) {
        super(target
            ,adjustmentValueChanged.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.awt.event.AdjustmentListener.adjustmentValueChanged()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface adjustmentValueChanged {}
    @Override public void adjustmentValueChanged(java.awt.event.AdjustmentEvent arg0) { fire(adjustmentValueChanged.class, arg0); } 

    
    
}