
package net.ericaro.neoevents.java.awt.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.awt.event.MouseWheelListener} that uses annotations to convert any objects into
 *  an MouseWheelListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>mouseWheelMoved</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addMouseWheelListener(new MouseWheelListener(this) );
 *     
 *     ...    
 *     
 *     &#64;MouseWheelListener.mouseWheelMoved
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the MouseWheelListener.mouseWheelMoved event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class MouseWheelListener extends AbstractEvent implements java.awt.event.MouseWheelListener{

    /** Creates an instance of Interface java.awt.event.MouseWheelListener that will forward every call to the target's methods annotated with:
     * <ul><li>mouseWheelMoved</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public MouseWheelListener(Object target) {
        super(target
            ,mouseWheelMoved.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.awt.event.MouseWheelListener.mouseWheelMoved()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface mouseWheelMoved {}
    @Override public void mouseWheelMoved(java.awt.event.MouseWheelEvent arg0) { fire(mouseWheelMoved.class, arg0); } 

    
    
}