
package net.ericaro.neoevents.java.beans;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.beans.VetoableChangeListener} that uses annotations to convert any objects into
 *  an VetoableChangeListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>vetoableChange</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addVetoableChangeListener(new VetoableChangeListener(this) );
 *     
 *     ...    
 *     
 *     &#64;VetoableChangeListener.vetoableChange
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the VetoableChangeListener.vetoableChange event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class VetoableChangeListener extends AbstractEvent implements java.beans.VetoableChangeListener{

    /** Creates an instance of Interface java.beans.VetoableChangeListener that will forward every call to the target's methods annotated with:
     * <ul><li>vetoableChange</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public VetoableChangeListener(Object target) {
        super(target
            ,vetoableChange.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.beans.VetoableChangeListener.vetoableChange()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface vetoableChange {}
    @Override public void vetoableChange(java.beans.PropertyChangeEvent arg0) { fire(vetoableChange.class, arg0); } 

    
    
}