
package net.ericaro.neoevents.java.beans.beancontext;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.beans.beancontext.BeanContextMembershipListener} that uses annotations to convert any objects into
 *  an BeanContextMembershipListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>childrenAdded</li>
<li>childrenRemoved</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addBeanContextMembershipListener(new BeanContextMembershipListener(this) );
 *     
 *     ...    
 *     
 *     &#64;BeanContextMembershipListener.childrenAdded
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the BeanContextMembershipListener.childrenAdded event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class BeanContextMembershipListener extends AbstractEvent implements java.beans.beancontext.BeanContextMembershipListener{

    /** Creates an instance of Interface java.beans.beancontext.BeanContextMembershipListener that will forward every call to the target's methods annotated with:
     * <ul><li>childrenAdded</li>
<li>childrenRemoved</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public BeanContextMembershipListener(Object target) {
        super(target
            ,childrenAdded.class
            ,childrenRemoved.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.beans.beancontext.BeanContextMembershipListener.childrenAdded()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface childrenAdded {}
    @Override public void childrenAdded(java.beans.beancontext.BeanContextMembershipEvent arg0) { fire(childrenAdded.class, arg0); } 


    /** Annotation to mark a method as a target for {@link java.beans.beancontext.BeanContextMembershipListener.childrenRemoved()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface childrenRemoved {}
    @Override public void childrenRemoved(java.beans.beancontext.BeanContextMembershipEvent arg0) { fire(childrenRemoved.class, arg0); } 

    
    
}