
package net.ericaro.neoevents.java.beans.beancontext;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.beans.beancontext.BeanContextServiceRevokedListener} that uses annotations to convert any objects into
 *  an BeanContextServiceRevokedListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>serviceRevoked</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addBeanContextServiceRevokedListener(new BeanContextServiceRevokedListener(this) );
 *     
 *     ...    
 *     
 *     &#64;BeanContextServiceRevokedListener.serviceRevoked
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the BeanContextServiceRevokedListener.serviceRevoked event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class BeanContextServiceRevokedListener extends AbstractEvent implements java.beans.beancontext.BeanContextServiceRevokedListener{

    /** Creates an instance of Interface java.beans.beancontext.BeanContextServiceRevokedListener that will forward every call to the target's methods annotated with:
     * <ul><li>serviceRevoked</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public BeanContextServiceRevokedListener(Object target) {
        super(target
            ,serviceRevoked.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.beans.beancontext.BeanContextServiceRevokedListener.serviceRevoked()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface serviceRevoked {}
    @Override public void serviceRevoked(java.beans.beancontext.BeanContextServiceRevokedEvent arg0) { fire(serviceRevoked.class, arg0); } 

    
    
}