
package net.ericaro.neoevents.java.beans.beancontext;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.beans.beancontext.BeanContextServicesListener} that uses annotations to convert any objects into
 *  an BeanContextServicesListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>serviceAvailable</li>
<li>serviceRevoked</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addBeanContextServicesListener(new BeanContextServicesListener(this) );
 *     
 *     ...    
 *     
 *     &#64;BeanContextServicesListener.serviceAvailable
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the BeanContextServicesListener.serviceAvailable event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class BeanContextServicesListener extends AbstractEvent implements java.beans.beancontext.BeanContextServicesListener{

    /** Creates an instance of Interface java.beans.beancontext.BeanContextServicesListener that will forward every call to the target's methods annotated with:
     * <ul><li>serviceAvailable</li>
<li>serviceRevoked</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public BeanContextServicesListener(Object target) {
        super(target
            ,serviceAvailable.class
            ,serviceRevoked.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.beans.beancontext.BeanContextServicesListener.serviceAvailable()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface serviceAvailable {}
    @Override public void serviceAvailable(java.beans.beancontext.BeanContextServiceAvailableEvent arg0) { fire(serviceAvailable.class, arg0); } 


    /** Annotation to mark a method as a target for {@link java.beans.beancontext.BeanContextServicesListener.serviceRevoked()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface serviceRevoked {}
    @Override public void serviceRevoked(java.beans.beancontext.BeanContextServiceRevokedEvent arg0) { fire(serviceRevoked.class, arg0); } 

    
    
}