
package net.ericaro.neoevents.java.util.prefs;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.util.prefs.NodeChangeListener} that uses annotations to convert any objects into
 *  an NodeChangeListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>childAdded</li>
<li>childRemoved</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addNodeChangeListener(new NodeChangeListener(this) );
 *     
 *     ...    
 *     
 *     &#64;NodeChangeListener.childAdded
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the NodeChangeListener.childAdded event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class NodeChangeListener extends AbstractEvent implements java.util.prefs.NodeChangeListener{

    /** Creates an instance of Interface java.util.prefs.NodeChangeListener that will forward every call to the target's methods annotated with:
     * <ul><li>childAdded</li>
<li>childRemoved</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public NodeChangeListener(Object target) {
        super(target
            ,childAdded.class
            ,childRemoved.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.util.prefs.NodeChangeListener.childAdded()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface childAdded {}
    @Override public void childAdded(java.util.prefs.NodeChangeEvent arg0) { fire(childAdded.class, arg0); } 


    /** Annotation to mark a method as a target for {@link java.util.prefs.NodeChangeListener.childRemoved()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface childRemoved {}
    @Override public void childRemoved(java.util.prefs.NodeChangeEvent arg0) { fire(childRemoved.class, arg0); } 

    
    
}