
package net.ericaro.neoevents.java.util.prefs;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link java.util.prefs.PreferenceChangeListener} that uses annotations to convert any objects into
 *  an PreferenceChangeListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>preferenceChange</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addPreferenceChangeListener(new PreferenceChangeListener(this) );
 *     
 *     ...    
 *     
 *     &#64;PreferenceChangeListener.preferenceChange
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the PreferenceChangeListener.preferenceChange event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class PreferenceChangeListener extends AbstractEvent implements java.util.prefs.PreferenceChangeListener{

    /** Creates an instance of Interface java.util.prefs.PreferenceChangeListener that will forward every call to the target's methods annotated with:
     * <ul><li>preferenceChange</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public PreferenceChangeListener(Object target) {
        super(target
            ,preferenceChange.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link java.util.prefs.PreferenceChangeListener.preferenceChange()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface preferenceChange {}
    @Override public void preferenceChange(java.util.prefs.PreferenceChangeEvent arg0) { fire(preferenceChange.class, arg0); } 

    
    
}