
package net.ericaro.neoevents.javax.imageio.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.imageio.event.IIOWriteWarningListener} that uses annotations to convert any objects into
 *  an IIOWriteWarningListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>warningOccurred</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addIIOWriteWarningListener(new IIOWriteWarningListener(this) );
 *     
 *     ...    
 *     
 *     &#64;IIOWriteWarningListener.warningOccurred
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the IIOWriteWarningListener.warningOccurred event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class IIOWriteWarningListener extends AbstractEvent implements javax.imageio.event.IIOWriteWarningListener{

    /** Creates an instance of Interface javax.imageio.event.IIOWriteWarningListener that will forward every call to the target's methods annotated with:
     * <ul><li>warningOccurred</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public IIOWriteWarningListener(Object target) {
        super(target
            ,warningOccurred.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.imageio.event.IIOWriteWarningListener.warningOccurred()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface warningOccurred {}
    @Override public void warningOccurred(javax.imageio.ImageWriter arg0, int arg1, java.lang.String arg2) { fire(warningOccurred.class, arg0, arg1, arg2); } 

    
    
}