
package net.ericaro.neoevents.javax.naming.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.naming.event.NamingListener} that uses annotations to convert any objects into
 *  an NamingListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>namingExceptionThrown</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addNamingListener(new NamingListener(this) );
 *     
 *     ...    
 *     
 *     &#64;NamingListener.namingExceptionThrown
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the NamingListener.namingExceptionThrown event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class NamingListener extends AbstractEvent implements javax.naming.event.NamingListener{

    /** Creates an instance of Interface javax.naming.event.NamingListener that will forward every call to the target's methods annotated with:
     * <ul><li>namingExceptionThrown</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public NamingListener(Object target) {
        super(target
            ,namingExceptionThrown.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.naming.event.NamingListener.namingExceptionThrown()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface namingExceptionThrown {}
    @Override public void namingExceptionThrown(javax.naming.event.NamingExceptionEvent arg0) { fire(namingExceptionThrown.class, arg0); } 

    
    
}