
package net.ericaro.neoevents.javax.net.ssl;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.net.ssl.HandshakeCompletedListener} that uses annotations to convert any objects into
 *  an HandshakeCompletedListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>handshakeCompleted</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addHandshakeCompletedListener(new HandshakeCompletedListener(this) );
 *     
 *     ...    
 *     
 *     &#64;HandshakeCompletedListener.handshakeCompleted
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the HandshakeCompletedListener.handshakeCompleted event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class HandshakeCompletedListener extends AbstractEvent implements javax.net.ssl.HandshakeCompletedListener{

    /** Creates an instance of Interface javax.net.ssl.HandshakeCompletedListener that will forward every call to the target's methods annotated with:
     * <ul><li>handshakeCompleted</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public HandshakeCompletedListener(Object target) {
        super(target
            ,handshakeCompleted.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.net.ssl.HandshakeCompletedListener.handshakeCompleted()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface handshakeCompleted {}
    @Override public void handshakeCompleted(javax.net.ssl.HandshakeCompletedEvent arg0) { fire(handshakeCompleted.class, arg0); } 

    
    
}