
package net.ericaro.neoevents.javax.sound.midi;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.sound.midi.ControllerEventListener} that uses annotations to convert any objects into
 *  an ControllerEventListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>controlChange</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addControllerEventListener(new ControllerEventListener(this) );
 *     
 *     ...    
 *     
 *     &#64;ControllerEventListener.controlChange
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the ControllerEventListener.controlChange event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class ControllerEventListener extends AbstractEvent implements javax.sound.midi.ControllerEventListener{

    /** Creates an instance of Interface javax.sound.midi.ControllerEventListener that will forward every call to the target's methods annotated with:
     * <ul><li>controlChange</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public ControllerEventListener(Object target) {
        super(target
            ,controlChange.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.sound.midi.ControllerEventListener.controlChange()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface controlChange {}
    @Override public void controlChange(javax.sound.midi.ShortMessage arg0) { fire(controlChange.class, arg0); } 

    
    
}