
package net.ericaro.neoevents.javax.sound.midi;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.sound.midi.MetaEventListener} that uses annotations to convert any objects into
 *  an MetaEventListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>meta</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addMetaEventListener(new MetaEventListener(this) );
 *     
 *     ...    
 *     
 *     &#64;MetaEventListener.meta
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the MetaEventListener.meta event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class MetaEventListener extends AbstractEvent implements javax.sound.midi.MetaEventListener{

    /** Creates an instance of Interface javax.sound.midi.MetaEventListener that will forward every call to the target's methods annotated with:
     * <ul><li>meta</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public MetaEventListener(Object target) {
        super(target
            ,meta.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.sound.midi.MetaEventListener.meta()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface meta {}
    @Override public void meta(javax.sound.midi.MetaMessage arg0) { fire(meta.class, arg0); } 

    
    
}