
package net.ericaro.neoevents.javax.sound.sampled;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.sound.sampled.LineListener} that uses annotations to convert any objects into
 *  an LineListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>update</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addLineListener(new LineListener(this) );
 *     
 *     ...    
 *     
 *     &#64;LineListener.update
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the LineListener.update event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class LineListener extends AbstractEvent implements javax.sound.sampled.LineListener{

    /** Creates an instance of Interface javax.sound.sampled.LineListener that will forward every call to the target's methods annotated with:
     * <ul><li>update</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public LineListener(Object target) {
        super(target
            ,update.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.sound.sampled.LineListener.update()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface update {}
    @Override public void update(javax.sound.sampled.LineEvent arg0) { fire(update.class, arg0); } 

    
    
}