
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.CaretListener} that uses annotations to convert any objects into
 *  an CaretListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>caretUpdate</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addCaretListener(new CaretListener(this) );
 *     
 *     ...    
 *     
 *     &#64;CaretListener.caretUpdate
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the CaretListener.caretUpdate event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class CaretListener extends AbstractEvent implements javax.swing.event.CaretListener{

    /** Creates an instance of Interface javax.swing.event.CaretListener that will forward every call to the target's methods annotated with:
     * <ul><li>caretUpdate</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public CaretListener(Object target) {
        super(target
            ,caretUpdate.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.CaretListener.caretUpdate()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface caretUpdate {}
    @Override public void caretUpdate(javax.swing.event.CaretEvent arg0) { fire(caretUpdate.class, arg0); } 

    
    
}