
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.CellEditorListener} that uses annotations to convert any objects into
 *  an CellEditorListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>editingCanceled</li>
<li>editingStopped</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addCellEditorListener(new CellEditorListener(this) );
 *     
 *     ...    
 *     
 *     &#64;CellEditorListener.editingCanceled
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the CellEditorListener.editingCanceled event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class CellEditorListener extends AbstractEvent implements javax.swing.event.CellEditorListener{

    /** Creates an instance of Interface javax.swing.event.CellEditorListener that will forward every call to the target's methods annotated with:
     * <ul><li>editingCanceled</li>
<li>editingStopped</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public CellEditorListener(Object target) {
        super(target
            ,editingCanceled.class
            ,editingStopped.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.CellEditorListener.editingCanceled()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface editingCanceled {}
    @Override public void editingCanceled(javax.swing.event.ChangeEvent arg0) { fire(editingCanceled.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.CellEditorListener.editingStopped()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface editingStopped {}
    @Override public void editingStopped(javax.swing.event.ChangeEvent arg0) { fire(editingStopped.class, arg0); } 

    
    
}