
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.ChangeListener} that uses annotations to convert any objects into
 *  an ChangeListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>stateChanged</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addChangeListener(new ChangeListener(this) );
 *     
 *     ...    
 *     
 *     &#64;ChangeListener.stateChanged
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the ChangeListener.stateChanged event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class ChangeListener extends AbstractEvent implements javax.swing.event.ChangeListener{

    /** Creates an instance of Interface javax.swing.event.ChangeListener that will forward every call to the target's methods annotated with:
     * <ul><li>stateChanged</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public ChangeListener(Object target) {
        super(target
            ,stateChanged.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.ChangeListener.stateChanged()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface stateChanged {}
    @Override public void stateChanged(javax.swing.event.ChangeEvent arg0) { fire(stateChanged.class, arg0); } 

    
    
}