
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.HyperlinkListener} that uses annotations to convert any objects into
 *  an HyperlinkListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>hyperlinkUpdate</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addHyperlinkListener(new HyperlinkListener(this) );
 *     
 *     ...    
 *     
 *     &#64;HyperlinkListener.hyperlinkUpdate
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the HyperlinkListener.hyperlinkUpdate event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class HyperlinkListener extends AbstractEvent implements javax.swing.event.HyperlinkListener{

    /** Creates an instance of Interface javax.swing.event.HyperlinkListener that will forward every call to the target's methods annotated with:
     * <ul><li>hyperlinkUpdate</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public HyperlinkListener(Object target) {
        super(target
            ,hyperlinkUpdate.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.HyperlinkListener.hyperlinkUpdate()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface hyperlinkUpdate {}
    @Override public void hyperlinkUpdate(javax.swing.event.HyperlinkEvent arg0) { fire(hyperlinkUpdate.class, arg0); } 

    
    
}