
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.InternalFrameListener} that uses annotations to convert any objects into
 *  an InternalFrameListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>internalFrameActivated</li>
<li>internalFrameClosed</li>
<li>internalFrameClosing</li>
<li>internalFrameDeactivated</li>
<li>internalFrameDeiconified</li>
<li>internalFrameIconified</li>
<li>internalFrameOpened</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addInternalFrameListener(new InternalFrameListener(this) );
 *     
 *     ...    
 *     
 *     &#64;InternalFrameListener.internalFrameActivated
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the InternalFrameListener.internalFrameActivated event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class InternalFrameListener extends AbstractEvent implements javax.swing.event.InternalFrameListener{

    /** Creates an instance of Interface javax.swing.event.InternalFrameListener that will forward every call to the target's methods annotated with:
     * <ul><li>internalFrameActivated</li>
<li>internalFrameClosed</li>
<li>internalFrameClosing</li>
<li>internalFrameDeactivated</li>
<li>internalFrameDeiconified</li>
<li>internalFrameIconified</li>
<li>internalFrameOpened</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public InternalFrameListener(Object target) {
        super(target
            ,internalFrameActivated.class
            ,internalFrameClosed.class
            ,internalFrameClosing.class
            ,internalFrameDeactivated.class
            ,internalFrameDeiconified.class
            ,internalFrameIconified.class
            ,internalFrameOpened.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.InternalFrameListener.internalFrameActivated()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface internalFrameActivated {}
    @Override public void internalFrameActivated(javax.swing.event.InternalFrameEvent arg0) { fire(internalFrameActivated.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.InternalFrameListener.internalFrameClosed()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface internalFrameClosed {}
    @Override public void internalFrameClosed(javax.swing.event.InternalFrameEvent arg0) { fire(internalFrameClosed.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.InternalFrameListener.internalFrameClosing()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface internalFrameClosing {}
    @Override public void internalFrameClosing(javax.swing.event.InternalFrameEvent arg0) { fire(internalFrameClosing.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.InternalFrameListener.internalFrameDeactivated()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface internalFrameDeactivated {}
    @Override public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent arg0) { fire(internalFrameDeactivated.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.InternalFrameListener.internalFrameDeiconified()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface internalFrameDeiconified {}
    @Override public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent arg0) { fire(internalFrameDeiconified.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.InternalFrameListener.internalFrameIconified()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface internalFrameIconified {}
    @Override public void internalFrameIconified(javax.swing.event.InternalFrameEvent arg0) { fire(internalFrameIconified.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.InternalFrameListener.internalFrameOpened()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface internalFrameOpened {}
    @Override public void internalFrameOpened(javax.swing.event.InternalFrameEvent arg0) { fire(internalFrameOpened.class, arg0); } 

    
    
}