
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.ListSelectionListener} that uses annotations to convert any objects into
 *  an ListSelectionListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>valueChanged</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addListSelectionListener(new ListSelectionListener(this) );
 *     
 *     ...    
 *     
 *     &#64;ListSelectionListener.valueChanged
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the ListSelectionListener.valueChanged event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class ListSelectionListener extends AbstractEvent implements javax.swing.event.ListSelectionListener{

    /** Creates an instance of Interface javax.swing.event.ListSelectionListener that will forward every call to the target's methods annotated with:
     * <ul><li>valueChanged</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public ListSelectionListener(Object target) {
        super(target
            ,valueChanged.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.ListSelectionListener.valueChanged()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface valueChanged {}
    @Override public void valueChanged(javax.swing.event.ListSelectionEvent arg0) { fire(valueChanged.class, arg0); } 

    
    
}