
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.MenuDragMouseListener} that uses annotations to convert any objects into
 *  an MenuDragMouseListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>menuDragMouseDragged</li>
<li>menuDragMouseEntered</li>
<li>menuDragMouseExited</li>
<li>menuDragMouseReleased</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addMenuDragMouseListener(new MenuDragMouseListener(this) );
 *     
 *     ...    
 *     
 *     &#64;MenuDragMouseListener.menuDragMouseDragged
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the MenuDragMouseListener.menuDragMouseDragged event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class MenuDragMouseListener extends AbstractEvent implements javax.swing.event.MenuDragMouseListener{

    /** Creates an instance of Interface javax.swing.event.MenuDragMouseListener that will forward every call to the target's methods annotated with:
     * <ul><li>menuDragMouseDragged</li>
<li>menuDragMouseEntered</li>
<li>menuDragMouseExited</li>
<li>menuDragMouseReleased</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public MenuDragMouseListener(Object target) {
        super(target
            ,menuDragMouseDragged.class
            ,menuDragMouseEntered.class
            ,menuDragMouseExited.class
            ,menuDragMouseReleased.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.MenuDragMouseListener.menuDragMouseDragged()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface menuDragMouseDragged {}
    @Override public void menuDragMouseDragged(javax.swing.event.MenuDragMouseEvent arg0) { fire(menuDragMouseDragged.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.MenuDragMouseListener.menuDragMouseEntered()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface menuDragMouseEntered {}
    @Override public void menuDragMouseEntered(javax.swing.event.MenuDragMouseEvent arg0) { fire(menuDragMouseEntered.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.MenuDragMouseListener.menuDragMouseExited()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface menuDragMouseExited {}
    @Override public void menuDragMouseExited(javax.swing.event.MenuDragMouseEvent arg0) { fire(menuDragMouseExited.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.MenuDragMouseListener.menuDragMouseReleased()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface menuDragMouseReleased {}
    @Override public void menuDragMouseReleased(javax.swing.event.MenuDragMouseEvent arg0) { fire(menuDragMouseReleased.class, arg0); } 

    
    
}