
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.MenuKeyListener} that uses annotations to convert any objects into
 *  an MenuKeyListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>menuKeyPressed</li>
<li>menuKeyReleased</li>
<li>menuKeyTyped</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addMenuKeyListener(new MenuKeyListener(this) );
 *     
 *     ...    
 *     
 *     &#64;MenuKeyListener.menuKeyPressed
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the MenuKeyListener.menuKeyPressed event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class MenuKeyListener extends AbstractEvent implements javax.swing.event.MenuKeyListener{

    /** Creates an instance of Interface javax.swing.event.MenuKeyListener that will forward every call to the target's methods annotated with:
     * <ul><li>menuKeyPressed</li>
<li>menuKeyReleased</li>
<li>menuKeyTyped</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public MenuKeyListener(Object target) {
        super(target
            ,menuKeyPressed.class
            ,menuKeyReleased.class
            ,menuKeyTyped.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.MenuKeyListener.menuKeyPressed()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface menuKeyPressed {}
    @Override public void menuKeyPressed(javax.swing.event.MenuKeyEvent arg0) { fire(menuKeyPressed.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.MenuKeyListener.menuKeyReleased()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface menuKeyReleased {}
    @Override public void menuKeyReleased(javax.swing.event.MenuKeyEvent arg0) { fire(menuKeyReleased.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.MenuKeyListener.menuKeyTyped()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface menuKeyTyped {}
    @Override public void menuKeyTyped(javax.swing.event.MenuKeyEvent arg0) { fire(menuKeyTyped.class, arg0); } 

    
    
}