
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.PopupMenuListener} that uses annotations to convert any objects into
 *  an PopupMenuListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>popupMenuCanceled</li>
<li>popupMenuWillBecomeInvisible</li>
<li>popupMenuWillBecomeVisible</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addPopupMenuListener(new PopupMenuListener(this) );
 *     
 *     ...    
 *     
 *     &#64;PopupMenuListener.popupMenuCanceled
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the PopupMenuListener.popupMenuCanceled event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class PopupMenuListener extends AbstractEvent implements javax.swing.event.PopupMenuListener{

    /** Creates an instance of Interface javax.swing.event.PopupMenuListener that will forward every call to the target's methods annotated with:
     * <ul><li>popupMenuCanceled</li>
<li>popupMenuWillBecomeInvisible</li>
<li>popupMenuWillBecomeVisible</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public PopupMenuListener(Object target) {
        super(target
            ,popupMenuCanceled.class
            ,popupMenuWillBecomeInvisible.class
            ,popupMenuWillBecomeVisible.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.PopupMenuListener.popupMenuCanceled()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface popupMenuCanceled {}
    @Override public void popupMenuCanceled(javax.swing.event.PopupMenuEvent arg0) { fire(popupMenuCanceled.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.PopupMenuListener.popupMenuWillBecomeInvisible()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface popupMenuWillBecomeInvisible {}
    @Override public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent arg0) { fire(popupMenuWillBecomeInvisible.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.PopupMenuListener.popupMenuWillBecomeVisible()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface popupMenuWillBecomeVisible {}
    @Override public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent arg0) { fire(popupMenuWillBecomeVisible.class, arg0); } 

    
    
}