
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.RowSorterListener} that uses annotations to convert any objects into
 *  an RowSorterListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>sorterChanged</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addRowSorterListener(new RowSorterListener(this) );
 *     
 *     ...    
 *     
 *     &#64;RowSorterListener.sorterChanged
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the RowSorterListener.sorterChanged event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class RowSorterListener extends AbstractEvent implements javax.swing.event.RowSorterListener{

    /** Creates an instance of Interface javax.swing.event.RowSorterListener that will forward every call to the target's methods annotated with:
     * <ul><li>sorterChanged</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public RowSorterListener(Object target) {
        super(target
            ,sorterChanged.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.RowSorterListener.sorterChanged()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface sorterChanged {}
    @Override public void sorterChanged(javax.swing.event.RowSorterEvent arg0) { fire(sorterChanged.class, arg0); } 

    
    
}