
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.TableColumnModelListener} that uses annotations to convert any objects into
 *  an TableColumnModelListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>columnAdded</li>
<li>columnMarginChanged</li>
<li>columnMoved</li>
<li>columnRemoved</li>
<li>columnSelectionChanged</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addTableColumnModelListener(new TableColumnModelListener(this) );
 *     
 *     ...    
 *     
 *     &#64;TableColumnModelListener.columnAdded
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the TableColumnModelListener.columnAdded event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class TableColumnModelListener extends AbstractEvent implements javax.swing.event.TableColumnModelListener{

    /** Creates an instance of Interface javax.swing.event.TableColumnModelListener that will forward every call to the target's methods annotated with:
     * <ul><li>columnAdded</li>
<li>columnMarginChanged</li>
<li>columnMoved</li>
<li>columnRemoved</li>
<li>columnSelectionChanged</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public TableColumnModelListener(Object target) {
        super(target
            ,columnAdded.class
            ,columnMarginChanged.class
            ,columnMoved.class
            ,columnRemoved.class
            ,columnSelectionChanged.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.TableColumnModelListener.columnAdded()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface columnAdded {}
    @Override public void columnAdded(javax.swing.event.TableColumnModelEvent arg0) { fire(columnAdded.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.TableColumnModelListener.columnMarginChanged()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface columnMarginChanged {}
    @Override public void columnMarginChanged(javax.swing.event.ChangeEvent arg0) { fire(columnMarginChanged.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.TableColumnModelListener.columnMoved()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface columnMoved {}
    @Override public void columnMoved(javax.swing.event.TableColumnModelEvent arg0) { fire(columnMoved.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.TableColumnModelListener.columnRemoved()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface columnRemoved {}
    @Override public void columnRemoved(javax.swing.event.TableColumnModelEvent arg0) { fire(columnRemoved.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.TableColumnModelListener.columnSelectionChanged()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface columnSelectionChanged {}
    @Override public void columnSelectionChanged(javax.swing.event.ListSelectionEvent arg0) { fire(columnSelectionChanged.class, arg0); } 

    
    
}