
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.TableModelListener} that uses annotations to convert any objects into
 *  an TableModelListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>tableChanged</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addTableModelListener(new TableModelListener(this) );
 *     
 *     ...    
 *     
 *     &#64;TableModelListener.tableChanged
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the TableModelListener.tableChanged event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class TableModelListener extends AbstractEvent implements javax.swing.event.TableModelListener{

    /** Creates an instance of Interface javax.swing.event.TableModelListener that will forward every call to the target's methods annotated with:
     * <ul><li>tableChanged</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public TableModelListener(Object target) {
        super(target
            ,tableChanged.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.TableModelListener.tableChanged()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface tableChanged {}
    @Override public void tableChanged(javax.swing.event.TableModelEvent arg0) { fire(tableChanged.class, arg0); } 

    
    
}