
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.TreeExpansionListener} that uses annotations to convert any objects into
 *  an TreeExpansionListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>treeCollapsed</li>
<li>treeExpanded</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addTreeExpansionListener(new TreeExpansionListener(this) );
 *     
 *     ...    
 *     
 *     &#64;TreeExpansionListener.treeCollapsed
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the TreeExpansionListener.treeCollapsed event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class TreeExpansionListener extends AbstractEvent implements javax.swing.event.TreeExpansionListener{

    /** Creates an instance of Interface javax.swing.event.TreeExpansionListener that will forward every call to the target's methods annotated with:
     * <ul><li>treeCollapsed</li>
<li>treeExpanded</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public TreeExpansionListener(Object target) {
        super(target
            ,treeCollapsed.class
            ,treeExpanded.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.TreeExpansionListener.treeCollapsed()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface treeCollapsed {}
    @Override public void treeCollapsed(javax.swing.event.TreeExpansionEvent arg0) { fire(treeCollapsed.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.TreeExpansionListener.treeExpanded()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface treeExpanded {}
    @Override public void treeExpanded(javax.swing.event.TreeExpansionEvent arg0) { fire(treeExpanded.class, arg0); } 

    
    
}