
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.TreeWillExpandListener} that uses annotations to convert any objects into
 *  an TreeWillExpandListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>treeWillCollapse</li>
<li>treeWillExpand</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addTreeWillExpandListener(new TreeWillExpandListener(this) );
 *     
 *     ...    
 *     
 *     &#64;TreeWillExpandListener.treeWillCollapse
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the TreeWillExpandListener.treeWillCollapse event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class TreeWillExpandListener extends AbstractEvent implements javax.swing.event.TreeWillExpandListener{

    /** Creates an instance of Interface javax.swing.event.TreeWillExpandListener that will forward every call to the target's methods annotated with:
     * <ul><li>treeWillCollapse</li>
<li>treeWillExpand</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public TreeWillExpandListener(Object target) {
        super(target
            ,treeWillCollapse.class
            ,treeWillExpand.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.TreeWillExpandListener.treeWillCollapse()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface treeWillCollapse {}
    @Override public void treeWillCollapse(javax.swing.event.TreeExpansionEvent arg0) { fire(treeWillCollapse.class, arg0); } 


    /** Annotation to mark a method as a target for {@link javax.swing.event.TreeWillExpandListener.treeWillExpand()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface treeWillExpand {}
    @Override public void treeWillExpand(javax.swing.event.TreeExpansionEvent arg0) { fire(treeWillExpand.class, arg0); } 

    
    
}