
package net.ericaro.neoevents.javax.swing.event;

//GENERATED DO NOT EDIT

import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import net.ericaro.neoevents.AbstractEvent;

/**
 *  <p>This is a transparent {@link javax.swing.event.UndoableEditListener} that uses annotations to convert any objects into
 *  an UndoableEditListener. </p>
 * 
 * Annotating methods of any object with the following annotations: 
 *
 * <ul><li>undoableEditHappened</li>
</ul>
 *
 * will call those methods when the corresponding events is fired.
 * 
 * example
 * <p>
 * <pre>
 * public class MyController {
 *     
 *     ...
 *     
 *     Object source;
 * 
 *     ...
 * 
 *     source.addUndoableEditListener(new UndoableEditListener(this) );
 *     
 *     ...    
 *     
 *     &#64;UndoableEditListener.undoableEditHappened
 *     protected void go(){
 *     System.out.println("go! go! go!"); // called when source will trigger the UndoableEditListener.undoableEditHappened event
 *     }
 * 
 * }
 * 
 * methods can be either:
 * <ul>
 * <li>without parameters</li>
 * <li>without one parameter of any super type of the corresponding event type</li>
 * </ul>
 * 
 * </pre>
 * 
 * </p>
 * 
 *
 */
public class UndoableEditListener extends AbstractEvent implements javax.swing.event.UndoableEditListener{

    /** Creates an instance of Interface javax.swing.event.UndoableEditListener that will forward every call to the target's methods annotated with:
     * <ul><li>undoableEditHappened</li>
</ul>
     *
     * @param target the object that will receive events
     */
    public UndoableEditListener(Object target) {
        super(target
            ,undoableEditHappened.class

                
        );
    }
    
    
    /** Annotation to mark a method as a target for {@link javax.swing.event.UndoableEditListener.undoableEditHappened()} calls  */
    @Retention(RetentionPolicy.RUNTIME) public static @interface undoableEditHappened {}
    @Override public void undoableEditHappened(javax.swing.event.UndoableEditEvent arg0) { fire(undoableEditHappened.class, arg0); } 

    
    
}